    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------
    028     * ContourDataset.java
    029     * -------------------
    030     * (C) Copyright 2002-2004, by David M. O'Donnell and Contributors.
    031     *
    032     * Original Author:  David M. O'Donnell;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: ContourDataset.java,v 1.2.2.1 2005/10/25 21:30:20 mungady Exp $
    036     *
    037     * Changes (from 23-Jan-2003)
    038     * --------------------------
    039     * 23-Jan-2003 : Added standard header (DG);
    040     * 17-Jan-2004 : Added methods from DefaultContourDataset that are referenced
    041     *               by ContourPlot.  See bug 741048 (DG);
    042     *
    043     */
    044
    045    package org.jfree.data.contour;
    046
    047    import org.jfree.data.Range;
    048    import org.jfree.data.xy.XYZDataset;
    049
    050    /**
    051     * The interface through which JFreeChart obtains data in the form of (x, y, z)
    052     * items - used for XY and XYZ plots.
    053     *
    054     * @author David M. O'Donnell
    055     */
    056    public interface ContourDataset extends XYZDataset {
    057
    058        /**
    059         * Returns the smallest Z data value.
    060         *
    061         * @return The minimum Z value.
    062         */
    063        public double getMinZValue();
    064
    065        /**
    066         * Returns the largest Z data value.
    067         *
    068         * @return The maximum Z value.
    069         */
    070        public double getMaxZValue();
    071
    072        /**
    073         * Returns the array of Numbers representing the x data values.
    074         *
    075         * @return The array of x values.
    076         */
    077        public Number[] getXValues();
    078
    079        /**
    080         * Returns the array of Numbers representing the y data values.
    081         *
    082         * @return The array of y values.
    083         */
    084        public Number[] getYValues();
    085
    086        /**
    087         * Returns the array of Numbers representing the z data values.
    088         *
    089         * @return The array of z values.
    090         */
    091        public Number[] getZValues();
    092
    093        /**
    094         * Returns an int array contain the index into the x values.
    095         *
    096         * @return The X values.
    097         */
    098        public int[] indexX();
    099
    100        /**
    101         * Returns the index of the xvalues.
    102         *
    103         * @return The x values.
    104         */
    105        public int[] getXIndices();
    106
    107        /**
    108         * Returns the maximum z-value within visible region of plot.
    109         *
    110         * @param x  the x-value.
    111         * @param y  the y-value.
    112         *
    113         * @return The maximum z-value.
    114         */
    115        public Range getZValueRange(Range x, Range y);
    116
    117        /**
    118         * Returns true if axis are dates.
    119         *
    120         * @param axisNumber  the axis where 0-x, 1-y, and 2-z.
    121         *
    122         * @return <code>true</code> or <code>false</code>.
    123         */
    124        public boolean isDateAxis(int axisNumber);
    125
    126    }